// ****************************************************************************************************
function blockSaveAsPage(htmlBlock, briefFileName) 
	// сохраняет блок помощи как страницу в списке-кэше и/или файлах.
	// блоки предварительно форматируются.
	// обрамляются тегами <body> c добавлением <HEAD> , либо вставляются в таблицу-шаблон
	var pageHTML='';

	// сохранение в кеше
	pageHTML=htmlBlock;
	pages.valueAdd(cssIncludeGet() + pageHTML,briefFileName);
	if writeAsRitminformFiles then
		if not blockWriteAsRitminformFile(htmlBlock, briefFileName) then
			message("Error!!! blockWriteAsRitminformFile(htmlBlock, briefFileName) ");
		endif;
	endif;
	if writeAsHelpFiles then
		if not blockWriteAsHelpFiles(cssIncludeGet() + htmlBlock, briefFileName) then
			message("Error!!! blockWriteAsRitminformFile(htmlBlock, briefFileName) ");
		endif;
	endif;

endFunction; // blockSaveAsPage(htmlBlock, filename) 


// ****************************************************************************************************
function blockWriteAsHelpFiles(htmlBlock, briefFileName) 
	var textPage= htmlBlock;
	var	fullFileName=folderHelpFiles+slash+briefFileName; // +".htm" 
	сообщить("*R* " + fullFileName);

	если ФайлСуществует(fullFileName) тогда
		ФайлУдалить(fullFileName);
	конецесли ;

	return stringAppendToFile(textPage,fullFileName,"UTF8");
endfunction ; // blockWriteAsHelpFiles() 




// ****************************************************************************************************
function blockWriteAsRitminformFile(htmlBlock, briefFileName) 
	// folderName="W:\4\prgTest\helpHtml\";
	var shablon=строкаИзФайла(prgTestPath+slash+"v3shablon.html");
	var textPage= StringPartReplace(shablon, "<!-- <СОДЕРЖИМОЕ_ОСНОВНОГО_ОКНА> -->", htmlBlock, 1);
	var	fullFileName=folderRitminformFiles+slash+briefFileName; // +".htm"
	сообщить("** " + fullFileName);

	если ФайлСуществует(fullFileName) тогда
		ФайлУдалить(fullFileName);
	конецесли ;

	return stringAppendToFile(textPage,fullFileName,"CP1251");
endfunction ; // blockWriteAsRitminformFile() 




// ****************************************************************************************************
// возвращает список значений с данными для формирования страниц (результат парсинга JSON)
function helpDataValueListGet() 
	if ( isValueList(globalHelpDataValueList) ) then
		return globalHelpDataValueList;
	endif;

	var selectedFilename=helpFileNameGet();
	if 0=строкаДлина(selectedFilename) then
		return 0;
	endif;
	
	// сообщить("Считывается из "+selectedFilename);
	строка2=строкаИзФайла(selectedFilename);

	globalHelpDataValueList=parseJson( строка2 );
	// сообщить(isValueList(list));
	// сообщить( не isValueList(list));
	if ( не (isValueList(globalHelpDataValueList)) ) then
		return 0;
	endif;
	return globalHelpDataValueList;

endFunction; // helpDataGet() 

// ****************************************************************************************************
// возвращает имя файла или пустую строку
function helpFileNameGet() 

	fileNameStandart="localInterpretatorUtf8.json";

	fullFileNameInDeveloperPath="W:\4\prgTest"+slash+fileNameStandart;
	fullFileNameInBinPath=binaryPath()+slash+fileNameStandart;
	fullFileNameInBinPrgTestPath=binaryPath()+slash+"prgTest"+slash+fileNameStandart;
	fullFileNamePrgTestPath=prgTestPath+slash+fileNameStandart;

	если (файлСуществует(fullFileNameInDeveloperPath)) тогда
		selectedFilename=fullFileNameInDeveloperPath;
	иначеЕсли файлСуществует(fullFileNameInBinPath) тогда
		selectedFilename=fullFileNameInBinPath;
	иначеЕсли файлСуществует(fullFileNameInBinPrgTestPath) тогда
		selectedFilename=fullFileNameInBinPrgTestPath;
	иначеЕсли файлСуществует(fullFileNameInBinPrgTestPath) тогда
		selectedFilename=fullFileNamePrgTestPath;
	иначе 
		предупреждение("Не найден <br/><br/> "+fileNameStandart+"."+",<br/><br/>Вызов справки невозможен!");
		возврат "";
	конецЕсли;
	// сообщить("selectedFilename="+selectedFilename);
	возврат selectedFilename;
endFunction ; // helpFileNameGet() 


// ****************************************************************************************************
function pageFileNameGetByKey(key) 
	var fileName=строкаЧастьЗаменить(key,":","_")+".htm";
	return fileName;
endFunction;  // pageFileNameGetByKey(pages, folderName) 


// ****************************************************************************************************
// создает стандартные страницы (не особых форматов)
// для всех элементов-потомков
function pageCreateFromVL(VL, thisVlKey) 
	var tmp="";
	var i=0;
	// message("pagesCreateFromVL() with key ["+thisVlKey+"] **************************************************");
	// memoryDisplayVars();

	var currentTitle=stringTrimAll(string(VL.valueGetByPresentation("title")));
	var currentText='<a href="main.htm">Главная'+"</a><BR/><BR/>"+chr(10);
	currentText=currentText+stringTrimAll(string(VL.valueGetByPresentation("text")));
	// pages.valueAdd(classPage,classKey);	

	
	var currentElementsVl=VL.valueGetByPresentation("elements");
	var currentElement="";
	var currentElementKey="";
	var currentElementTitle="";
	if (isValueList(currentElementsVl)) then
		for i=1 to currentElementsVl.size() do 
			if 1=i then 
				currentText=currentText+"<BR/><BR/> См. так же<BR/><BR/>";
			endif;
	

			tmp=stringTrimAll(string(currentElementsVl.valuePresentationGet(i)));
			currentElement=currentElementsVl.valueGet(i);
			if (isValueList(currentElementsVl)) then
				currentElementTitle=stringTrimAll(string(currentElement.valueGetByPresentation("title")));
			endif;
			if 0=stringLen(currentElementTitle) then
				currentElementTitle=tmp;
			endif;
			

			// message("pagesCreateFromVL() element with key ["+tmp+"]");
			currentElementKey=thisVlKey+":"+tmp;
			pageCreateFromVL(currentElement, currentElementKey) ;
			currentText=currentText+'<BR/><a href="'+pageFileNameGetByKey(currentElementKey)+'">'+currentElementTitle+'</a><BR/>';
		enddo;
		
			// pageCreateFromVL(currentElementsVl, currentPresentation);
	endif;

	
//	pages.valueAdd(cssIncludeGet() + currentText,pageFileNameGetByKey(thisVlKey) );	
	blockSaveAsPage(currentText,pageFileNameGetByKey(thisVlKey) );	

endFunction; // pagesCreateFromVL(VL, thisVlKey) 



// ****************************************************************************************************
function pagesWriteToFolder(pages, folderName) 
	// folderName="W:\4\prgTest\helpHtml\";
	var fileName	="";
	for i=1 to pages.size() do // pages.size() 
		textPage=pages.valueGet(i);
		textKey=pages.valuePresentationGet(i);
		fileName=pageFileNameGetByKey(textKey) ;			
		fileName=folderName+fileName; // +".htm"
		сообщить("************************** "+textKey+" " + fileName);

		если ФайлСуществует(fileName) тогда
			ФайлУдалить(fileName);
		конецесли ;

////	сообщить(textPage);
		stringAppendToFile(textPage,fileName);
	enddo;
endfunction ; // pageWriteToFolder() 


// ****************************************************************************************************
function cssIncludeGet() 
	var bodyFontFamily = "Times New Roman";

	if isWINDOWS() then
		bodyFontFamily = "Arial Cyr";
	endif;

	stylesHTML="";
	stylesHTML=stylesHTML+'<META http-equiv=Content-Type content="text/html; charset=utf-8"/>';

	stylesHTML=stylesHTML+'<style type="text/css">'+chr(10);
//	body {	margin-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; color:#CCCCBB; background-color:None; }	
	stylesHTML=stylesHTML+'body {font-family: '+bodyFontFamily+' ; font: 12pt ; font-weight:NONE; text-align:justyfy; margin-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; color:None; background-color:white; }'+chr(10);
//	stylesHTML=stylesHTML+'body {font-family: '+bodyFontFamily+' ; font: 12pt ; font-weight:NONE; text-align:justyfy; margin-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; color:None; background-color:white; }'+chr(10);

	// stylesHTML=stylesHTML+'functionName {font-family: "Courier"; font: 12pt bold; display:none; font-weight:bold; color:black; }'+chr(10);

     
	stylesHTML=stylesHTML+'H1 {font-size: 200%; display:inline; font-weight:bold; }'+chr(10); // color:YELLOW; 
	stylesHTML=stylesHTML+'H2 {font-size: 150%; display:inline; font-weight:bold; }'+chr(10);
	stylesHTML=stylesHTML+'H3 {font-size: 125%; display:inline; font-weight:bold; }'+chr(10);
	stylesHTML=stylesHTML+'H4 {font-size: 110%; display:inline; font-weight:bold; }'+chr(10);
	stylesHTML=stylesHTML+'H5 {font-size: 100%; display:inline; font-weight:bold; }'+chr(10);
	stylesHTML=stylesHTML+'H6 {font-size: 100%; display:inline;                   }'+chr(10);

	stylesHTML=stylesHTML+'i{font-family: "Times New Roman" ; font-weight:NONE; font-style: italic; text-align:justyfy; margin-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; color:blue; background-color:None; }'+chr(10);
	stylesHTML=stylesHTML+'blueText{font-family: "Times New Roman" ; font-weight:BOLD; font-style: italic; text-align:justyfy; margin-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; color:blue; background-color:None; }'+chr(10);
	stylesHTML=stylesHTML+'code{color:cyan; font-family: "Times New Roman" ; font-weight:ITALIC; font-style: italic; text-align:justyfy; margin-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px; background-color:None; }'+chr(10);
	stylesHTML=stylesHTML+'a{color:green; display:inline;}'+chr(10);
    // stylesHTML=stylesHTML+'.CODE {display:block; margin-left:3%; margin-right:3%; padding-left:2%; padding-right:2%; background-color:Slateblue; color:Midnightblue; font-size:75%; font-weight:bold;}'+chr(10);
	var codeStyle='color:navy; font-size:100%; display:block; margin-left:3%; margin-right:3%; padding-left:2%; padding-right:2%; ';
    stylesHTML=stylesHTML+'.CODE {'+codeStyle+'}'+chr(10);
	stylesHTML=stylesHTML+'code{'+codeStyle+'}'+chr(10);
	stylesHTML=stylesHTML+'</style>'+chr(10);
	return stylesHTML;
endFunction;
// ****************************************************************************************************
function classPagesCreateFromVL(classVL) // при неудаче возвращает 0;
	if (not isValueList(classVL)) then
		return 0;
	endif;
	var thisClassVL=0;
	for i=1 to classVl.size() do
		thisClassVL=classVl.valueGet(i);
		classNameEn=строка(thisClassVL.valueGetByPresentation("nameEn"));
		classNameRu=строка(thisClassVL.valueGetByPresentation("nameRu"));
		// v=classGetVlByName(classNameEn);
		// v=classGetVlByName(classNameEn);
		// classNameRu1=classGetAttributeByName(classNameEn, "nameRu");
		// classNameRu1=строка(v.valueGetByPresentation("nameRu"));
		// message("class:"+classNameRu1);
		classKey="class:"+stringToUpper(classNameEn);
		// thisClassPage=classGetHelpFromVL(thisClassVL);
		// thisClassVL.show();
		classHtmlBlock=classGetHtmlBlockFromVL(thisClassVL);
		
		// pages.valueAdd(classPage,pageFileNameGetByKey(classKey));	
		blockSaveAsPage(classHtmlBlock,pageFileNameGetByKey(classKey));	


		// создаю все страницы для методов класса
		methodsVl=thisClassVL.valueGetByPresentation("method");
		for m=1 to methodsVl.size() do
			thisMethodVl=methodsVl.valueGet(m);
		
			methodNameEn=строка(thisMethodVl.valueGetByPresentation("nameEn"));
			methodPage=methodGetHtmlBlockFromVL(thisMethodVl,classNameEn);

			// pages.valueAdd(methodPage,pageFileNameGetByKey(classKey+":method:"+stringToUpper(methodNameEn)) );	
			blockSaveAsPage(methodPage,pageFileNameGetByKey(classKey+":method:"+stringToUpper(methodNameEn)) );	


		enddo;
		
	enddo;
	// КОНЕЦ разбираю КЛАССЫ
	return 1;
endFunction;//  classPagesCreateFromVL(classVL) // при неудаче возвращает 0;



// ****************************************************************************************************
function classGetAttributeByName(className, attrName) // если не найден, то возвращает "";
	var результат="";
	var thisClassVL=classGetVlByName(className);
	if (isValueList(thisClassVL)) then
		результат=thisClassVL.valueGetByPresentation(attrName);
	endif;
	возврат результат;	
endFunction; // classGetAttributeByName(className) // если не найден, то возвращает "";

// ****************************************************************************************************
function classGetVlByName(className) // если не найден, то возвражает 0;
	var classNameEnInUpperCase=stringToUpper(className);
	// message("classGetVlByName()  ************************************* className="+className);
	// memoryDisplayVars();
	var list=helpDataValueListGet();
	if (не isValueList(list)) then
		return "";
	endif;
	// message("list = "+string(list));

	var classesVl=list.valueGetByPresentation("class");
	if (не isValueList(classesVl)) then
		return "";
	endif;
	// message("classesVl = "+string(classesVl));
	// classesVl.show(className);

	var thisClassVL=0;
	for щ=1 по classesVl.size()  do
		thisClassVL=classesVl.valueGet(щ);
		if (isValueList(thisClassVL)) then
			classNameEn=строка(thisClassVL.valueGetByPresentation("nameEn"));
			classNameRu=строка(thisClassVL.valueGetByPresentation("nameRu"));
			if ((classNameEn=className) or (classNameRu=className) ) then
				return thisClassVL; 
			endif;
		endif;
		// message("classVl = "+string(thisClassVL));
	enddo;

	return 0; // result ;
endFunction;

// ****************************************************************************************************
function classGetHtmlBlockFromVL(thisClassVl) 
	// возввращает строку со страницей описания метода
	classNameEn=строка(thisClassVL.valueGetByPresentation("nameEn"));
	classNameRu=строка(thisClassVL.valueGetByPresentation("nameRu"));
	text=строка(thisClassVL.valueGetByPresentation("text"));
	methodsVl=thisClassVL.valueGetByPresentation("method");

//	сообщить("Разбираю класс "+classNameEn+ " методов "+строка(methodsVl.size()));
	classHelpBlock="";
	classHelpBlock=classHelpBlock+'<a href="main.htm">Главная'+"</a><BR/><BR/>"+chr(10);

	classHelpBlock=classHelpBlock+'Класс <b>'+classNameEn+' ('+classNameRu+') </b> <BR/><BR/>';
	classKey="class:"+stringToUpper(classNameEn);
	classHelpBlock=classHelpBlock+text+"<BR/><BR/>";

	classHelpBlock=classHelpBlock+"Доступные методы:<BR/><BR/>"+chr(10);
		
	var linkString="";
	var memberFirstLetter="";
	for m=1 to methodsVl.size() do
		thisMethodVl=methodsVl.valueGet(m);
		
		methodNameEn=строка(thisMethodVl.valueGetByPresentation("nameEn"));
		
		if (memberFirstLetter <> stringPartLeft(methodNameEn,1)) then
			memberFirstLetter=stringPartLeft(methodNameEn,1);
			classHelpBlock=classHelpBlock+'<B>'+memberFirstLetter+"</B><BR/>"+chr(10);
		endif;

		// methodPage=methodGetHtmlBlockFromVL(thisMethodVl,classKey);

		// ссылка на метод
		// <a href=\"#class:CONTEXT\">КОНТЕКСТ</a>
		linkString = pageFileNameGetByKey(classKey+":method:"+stringToUpper(methodNameEn));
		classHelpBlock=classHelpBlock+'<a href="'+linkString+'">'+methodNameEn+"()</a><BR/>"+chr(10);

		// message('<a href="#'+classKey+":method:"+methodNameEn+'">'+methodNameEn+"()</a><BR/>");
		// classPage=classPage+""+methodNameEn+"()<BR/>"+chr(10);
	enddo;

	return classHelpBlock;

endfunction;

// ****************************************************************************************************	

function methodGetHtmlBlockFromVL(thisMethodVl,className) 
	var classNameRu=classGetAttributeByName(className, "nameRu");
	var classNameEn=classGetAttributeByName(className, "nameEn");


	// возввращает строку со страницей описания метода
	tabOtstup="&nbsp;&nbsp;&nbsp;&nbsp;";
	// methodPage=строка(thisMethodVl);
	// сообщить(thisMethodVl);

	methodNameEn=строка(thisMethodVl.valueGetByPresentation("nameEn"));
	methodNameRu=строка(thisMethodVl.valueGetByPresentation("nameRu"));
	// message("methodNameRu="+строка(methodNameRu)+" для класса "+строка(classNameRu));


	methodSyntax=строка(thisMethodVl.valueGetByPresentation("syntax"));
	methodReturnValue=строка(thisMethodVl.valueGetByPresentation("returnValue"));

	methodPage="";
	methodPage=methodPage+'<a href="'+pageFileNameGetByKey('main')+'">Главная'+"</a><BR/>"+chr(10);
//	pol='<a href="#class:'+stringToUpper(classNameEn)+'">класс '+classNameRu+'</a><BR/>';
//	message(pol);
	methodPage=methodPage+'<a href="'+pageFileNameGetByKey('class:'+stringToUpper(classNameEn))+'">класс '+classNameRu+'</a><BR/>'+chr(10);
	methodPage=methodPage+"<BR/>"+chr(10);
	methodPage=methodPage+'<div class="ThisBlock">'+chr(10);
	methodPage=methodPage+"<i>метод</i><H3> "+methodNameEn+" </H3>";
	если (0<строкаДлина(строкаСокрЛП(methodNameRu))) тогда
		methodPage=methodPage+"<i>или</i><H3> "+methodNameRu+" </H3>";
	конецЕсли;
	methodPage=methodPage+"<BR/>"+chr(10);
	methodPage=methodPage+"<H4>Синтаксис:</H4> <BR/>"+chr(10);
	methodPage=methodPage+(tabOtstup+""+methodSyntax+""+"<BR/>"+chr(10));
	methodPage=methodPage+"<BR/>"+chr(10);
	methodPage=methodPage+"<H4>Параметры:</H4> "+chr(10); // <BR/>

	parametersVl=thisMethodVl.valueGetByPresentation("parameter");
	// естьПараметры="";
	если ("СПИСОКЗНАЧЕНИЙ"=valueTypeAsString(parametersVl)) тогда
			methodPage=methodPage+'<table width=95%  border="0" style="margin-left:10px; border-style:dotted;"><BR/>'+chr(10); //
			methodPage=methodPage+'<tbody>'+chr(10);


		для параметрНомер=1 по parametersVl.size()  цикл
			параметрОписание=	строка(parametersVl.значениеПолучить(параметрНомер));
			параметрИмя=		строка(parametersVl.значениеПредставлениеПолучить(параметрНомер));
			// methodPage=methodPage+tabOtstup+'&lt;'+параметрИмя+'&gt; - '+параметрОписание+chr(10);

			methodPage=methodPage+'<tr>'+chr(10);
			methodPage=methodPage+'<id="tH" style="text-align:left; background-color:transparent;">'+chr(10); // vertical-align: middle; 
			methodPage=methodPage+'<td width=100 style="max-width:150px; min-width:50px; ">'+параметрИмя+'</td>'+chr(10); // width=200  style="vertical-align: middle";  // width=50 
			// methodPage=methodPage+'<td width=5 ></td>'+chr(10);
			methodPage=methodPage+'<td width=20 align="center" >'+''+'-'+'</td>'+chr(10); // style="vertical-align: middle; "
			methodPage=methodPage+'<td align="left" style="vertical-align: middle; ">'+''+параметрОписание+'<BR/></td>'+chr(10);
			methodPage=methodPage+'</id>'+chr(10);
			methodPage=methodPage+'</tr>'+chr(10);

			// пропуск строки
			// methodPage=methodPage+'<tr><td width=5 ></td></tr>'+chr(10);

		конецЦикла;


		methodPage=methodPage+'</tbody>'+chr(10);
		methodPage=methodPage+'</table>'+chr(10);
		methodPage=methodPage+"<BR/>"+chr(10);
		// methodPage=methodPage+"<BR/>"+chr(10);
		
	конецЕсли;

	// *************************************************************************************************
	// methodPage=methodPage+"<BR/>"+chr(10);
	methodPage=methodPage+"<H4>Возвращаемое значение:</H4>"+chr(10);
	methodPage=methodPage+"<BR/>"+chr(10);
	methodPage=methodPage+(tabOtstup+methodReturnValue+"<BR>")+chr(10);
	methodPage=methodPage+"<BR/>"+chr(10);


	// *************************************************************************************************
	methodPage=methodPage+"<H4>Описание:</H4><BR/>"+chr(10);
	methodDescription=строка(thisMethodVl.valueGetByPresentation("description"));
	methodPage=methodPage+methodDescription+'<BR/>'+chr(10);

	// *************************************************************************************************
	methodPage=methodPage+"<H4>Пример:</H4>"+chr(10);


	methodExample=строка(thisMethodVl.valueGetByPresentation("example"));


	methodPage=methodPage+'<table width=95% border="0" style="margin-left:10px;">'+chr(10);
	methodPage=methodPage+'<tbody>'+chr(10);


	methodPage=methodPage+'<tr>'+chr(10);
	methodPage=methodPage+'<id="tH" style="vertical-align: middle; text-align:left; background-color:transparent;">'+chr(10);
//	methodPage=methodPage+'<td align="left" style="vertical-align: middle; ">'+'<pre>'+methodExample+'</pre>'+'</td>'+chr(10);
	methodPage=methodPage+'<td align="left" style="vertical-align: middle; ">'+'<div class="CODE"><pre>'+methodExample+'</pre><div>'+'</td>'+chr(10);
	methodPage=methodPage+'</id>'+chr(10);
	methodPage=methodPage+'</tr>'+chr(10);
	methodPage=methodPage+'</tbody>'+chr(10);
	methodPage=methodPage+'</table>'+chr(10);


	methodPage=methodPage+"</H4>Ссылки:</H4><BR>";
	methodPage=methodPage+"<BR/>";


	var linkString ="";
	var Key="";
	seeAlsoVl=thisMethodVl.valueGetByPresentation("seeAlso");
	// естьПараметры="";
	если (isVAlueList(seeAlsoVl)) тогда	
		для параметрНомер=1 по seeAlsoVl.size()  цикл
			Description=	строка(seeAlsoVl.значениеПолучить(параметрНомер));
			// Key=		stringToUpper(строка(seeAlsoVl.значениеПредставлениеПолучить(параметрНомер)));
			Key=		строка(seeAlsoVl.значениеПредставлениеПолучить(параметрНомер));
			// methodPage=methodPage+tabOtstup+'&lt;'+параметрИмя+'&gt; - '+параметрОписание+chr(10);
			linkString = pageFileNameGetByKey(Key);			
			methodPage=methodPage+'<a href="'+linkString+'"> '+Description+'</a><BR/>';

			// methodPage=methodPage+Key+'<BR/>'+chr(10);


		конецЦикла;


		methodPage=methodPage+"<BR/>"+chr(10);
		
	конецЕсли;



	// methodPage=methodPage+"<a href=\"#class:"+className+L"\" >класс "+className+L"</a>\n";



//	methodPage=methodPage+"<pre>"+chr(10);
//	methodPage=methodPage+methodExample+"<BR/>";
//	methodPage=methodPage+"</pre>"+chr(10);


	methodPage=methodPage+'</div class="ThisBlock">'+chr(10);


	возврат methodPage;
endFunction;


// ****************************************************************************************************
function тестHelp() 

	var list=helpDataValueListGet();
	// list=helpDataValueListGet();
	// memoryDisplayVars();
	// classGetVlByName("className");
	if ( не (isValueList(list)) ) then
		return 0;
	endif;
	// list.show();	

	pages=createObject("СписокЗначений");	

	// list.show();
	var mainVL=list.valueGetByPresentation("main");
	// mainVL.show();
	
	var mainText=mainVL.valueGetByPresentation("text");
	// message(mainText);
	// ? mainText;
	
	// pages.valueAdd(mainText,"main.htm");
	blockSaveAsPage(mainText,"main.htm");

	// list.show();	

	var i=0;
	var currentPresentation="";
	var Ok=false;
	var currentVl=0;
	for i=1 to list.size() do
		currentPresentation=list.valuePresentationGet(i);
		// message("["+currentPresentation+"]");

		if ("class"=currentPresentation) then
			// разбираю КЛАССЫ ****************************************************
			// classVl=list.valueGetByPresentation("class");
			currentVl=list.valueGet(i);
			// classVl.show();
			Ok=(1=classPagesCreateFromVL(currentVl));
			if (!Ok) then
				messageBox("НЕ удалось ссоздать страницы справки по классам!");
				возврат 0;
			endif;
		elseif ("language"=currentPresentation) then
			// message("this is ["+currentPresentation+"]");
			currentVl=list.valueGet(i);
			if (isValueList(currentVl)) then
				pageCreateFromVL(currentVl, currentPresentation);
			endif;
		endif;
	enddo;

	// pages.show();


	___TEST__TEXTBROWSER(pages);

	// сообщить(valueTypeAsString(classVl));
	возврат 1;
endFunction;





//************************************************************************************************************
//************************************************************************************************************
//***    implementation **************************************************************************************
//************************************************************************************************************
if isWindows() then slash="\"; 
else slash="/"; 
endif;
prgTestPath=".";
folderHelpFiles=prgTestPath+slash+"helpHtml";
folderRitminformFiles=prgTestPath+slash+"helpRitminform";

list=0;
globalHelpDataValueList=""; // результат парсинга JSON с данными помощи

writeAsHelpFiles=ложь;
writeAsRitminformFiles=ложь;

// memoryDisplayData();
// memoryDisplayVars();
if 0=тестHelp() then
	предупреждение("Вывод справки невозможен!");
endif;